# Forceload map

forceload add -32 -64 31 47







# Set values

scoreboard players set #phase value 0
scoreboard players reset * character
scoreboard players add #high_score value 0
scoreboard players set #score value 0
scoreboard players set #lives value 3
scoreboard players set #extra_lives value 0
scoreboard players set #level value 1
scoreboard players set #scene_animation value 0
scoreboard players set #arena_animation value 0
scoreboard players set #pellet_timer value 0
scoreboard players set #death_boolean value 0
scoreboard players set #intermission value 0
scoreboard players set #secret_boolean value 0







# Prepare arena

clone -29 3 -33 29 3 31 -29 17 -33 filtered #pacman:wall
execute if score #short_walls value matches 0 run clone -29 2 -33 29 3 31 -29 18 -33 filtered #pacman:wall
execute if score #short_walls value matches 1 run clone -29 4 -33 29 5 31 -29 18 -33 filtered #pacman:wall

clone -30 16 -34 30 16 32 -30 17 -34 filtered white_concrete
fill -30 17 -34 30 17 32 stone_button[facing=south,face=floor] replace white_concrete

clone -30 16 -34 30 16 32 -30 18 -34 filtered yellow_concrete
fill -30 18 -34 30 18 32 structure_void replace yellow_concrete

scoreboard players set #pellet_count value 244







# Prepare entities

kill @e[type=!player]

summon area_effect_cloud 000 16.525 -17 {Tags:["game","pacman"        ],Age:-2147483648,Duration:-1,WaitTime:-2147483648,Passengers:[{id:"armor_stand",Tags:["game","pacman"        ],NoGravity:1,Invisible:1,DisabledSlots:4144959}]}
summon area_effect_cloud 000 16.525 007 {Tags:["game","blinky","ghost"],Age:-2147483648,Duration:-1,WaitTime:-2147483648,Passengers:[{id:"armor_stand",Tags:["game","blinky","ghost"],NoGravity:1,Invisible:1,DisabledSlots:4144959}]}
summon area_effect_cloud 000 16.525 001 {Tags:["game","pinky" ,"ghost"],Age:-2147483648,Duration:-1,WaitTime:-2147483648,Passengers:[{id:"armor_stand",Tags:["game","pinky" ,"ghost"],NoGravity:1,Invisible:1,DisabledSlots:4144959}]}
summon area_effect_cloud 004 16.525 001 {Tags:["game","inky"  ,"ghost"],Age:-2147483648,Duration:-1,WaitTime:-2147483648,Passengers:[{id:"armor_stand",Tags:["game","inky"  ,"ghost"],NoGravity:1,Invisible:1,DisabledSlots:4144959}]}
summon area_effect_cloud -04 16.525 001 {Tags:["game","clyde" ,"ghost"],Age:-2147483648,Duration:-1,WaitTime:-2147483648,Passengers:[{id:"armor_stand",Tags:["game","clyde" ,"ghost"],NoGravity:1,Invisible:1,DisabledSlots:4144959}]}

scoreboard players set @e[type=armor_stand,tag=game,tag=pacman,limit=1] direction 1
scoreboard players set @e[type=armor_stand,tag=game,tag=blinky,limit=1] direction 1
scoreboard players set @e[type=armor_stand,tag=game,tag=pinky ,limit=1] direction 2
scoreboard players set @e[type=armor_stand,tag=game,tag=inky  ,limit=1] direction 0
scoreboard players set @e[type=armor_stand,tag=game,tag=clyde ,limit=1] direction 0

scoreboard players set @e[type=armor_stand,tag=game,tag=ghost ] turn 0
scoreboard players set @e[type=armor_stand,tag=game] mode 0
scoreboard players set @e[type=armor_stand,tag=game] warp_timer 0







# Spawn pellet markers for Pac-Man AI

summon area_effect_cloud -03 17 -17 {Tags:["pellet"               ],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 003 17 -17 {Tags:["pellet"               ],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -09 17 -11 {Tags:["pellet"               ],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 009 17 -11 {Tags:["pellet"               ],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -15 17 001 {Tags:["pellet"               ],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 015 17 001 {Tags:["pellet"               ],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -03 17 013 {Tags:["pellet"               ],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 003 17 013 {Tags:["pellet"               ],Age:-2147483648,Duration:-1,WaitTime:-2147483648}

summon area_effect_cloud -25 17 -17 {Tags:["pellet","power_pellet"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 025 17 -17 {Tags:["pellet","power_pellet"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -25 17 023 {Tags:["pellet","power_pellet"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 025 17 023 {Tags:["pellet","power_pellet"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}

execute as @e[type=area_effect_cloud,tag=pellet] run function pacman:generic/data/get/xz_int







# Spawn intersection marker

summon area_effect_cloud -03 17 -29 {Tags:["intersection"         ],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 003 17 -29 {Tags:["intersection"         ],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -21 17 -23 {Tags:["intersection"         ],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 021 17 -23 {Tags:["intersection"         ],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -15 17 -17 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 015 17 -17 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -09 17 -17 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 009 17 -17 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -03 17 -17 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 003 17 -17 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -15 17 -11 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 015 17 -11 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -09 17 -11 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 009 17 -11 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -09 17 -05 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 009 17 -05 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -15 17 001 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 015 17 001 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -09 17 001 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 009 17 001 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -03 17 007 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 003 17 007 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -15 17 013 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 015 17 013 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -25 17 019 {Tags:["intersection"         ],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 025 17 019 {Tags:["intersection"         ],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -15 17 019 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 015 17 019 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -09 17 019 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 009 17 019 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -03 17 019 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 003 17 019 {Tags:["intersection","center"],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud -15 17 027 {Tags:["intersection"         ],Age:-2147483648,Duration:-1,WaitTime:-2147483648}
summon area_effect_cloud 015 17 027 {Tags:["intersection"         ],Age:-2147483648,Duration:-1,WaitTime:-2147483648}

execute as @e[type=area_effect_cloud,tag=intersection] run function pacman:generic/data/get/xz_int







# Clear title

title @a actionbar ""
title @a title ""







# Stop sounds

stopsound @a master pacman:siren_1
stopsound @a master pacman:siren_2
stopsound @a master pacman:siren_3
stopsound @a master pacman:siren_4
stopsound @a master pacman:siren_5
stopsound @a master pacman:power_pellet
stopsound @a master pacman:retreating







# Display numbers

scoreboard players operation #input value = #high_score value
execute positioned -5 41 32 run function pacman:animation/number/main

scoreboard players operation #input value = #score value
execute positioned 15 41 32 run function pacman:animation/number/main







# Displace title

fill -9 37 32 9 37 32 black_concrete







# Display lives and level

function pacman:animation/lives
function pacman:animation/level







# Set settings wall

clone -29 49 -48 29 63 -47 -29 49 -34